package net.codinux.banking.client.fints4k

import net.codinux.banking.client.BankingClient
import net.codinux.banking.client.BankingClientCallback
import net.codinux.banking.client.model.options.GetAccountDataOptions
import net.codinux.banking.client.model.request.GetAccountDataRequest
import net.codinux.banking.client.model.response.GetAccountDataResponse
import net.codinux.banking.client.model.response.Response
import net.codinux.banking.fints.FinTsClient
import net.codinux.banking.fints.config.FinTsClientConfiguration

open class FinTs4kBankingClient(
    config: FinTsClientConfiguration = FinTsClientConfiguration(),
    callback: BankingClientCallback
) : BankingClient {

    constructor(callback: BankingClientCallback) : this(FinTsClientConfiguration(), callback)


    protected val mapper = FinTs4kMapper()

    protected val client = FinTsClient(config, BridgeFintTsToBankingClientCallback(callback, mapper))


    override suspend fun getAccountDataAsync(request: GetAccountDataRequest): Response<GetAccountDataResponse> {
        val response = client.getAccountDataAsync(mapper.mapToGetAccountDataParameter(request, request.options ?: GetAccountDataOptions()))

        return mapper.map(response)
    }

}